{---------------------------------------------------------------------------
                           O L I F C T S . P A S
----------------------------------------------------------------------------
Cette Unit regroupe tout un tas de fonctions et procdures bien utiles pour
grer des chaines, des nombres et un paquet d'autres choses utilises dans
Schmurtz                                                                  }

{$N+}
{$E+}

Unit OliFcts;

interface

Function OStr(Nombre : Longint) : String;
Function OStrR(Nombre : real) : String;
Function OVal(Chaine : String) : Longint;
Function OValR(Chaine : String) : Real;
function UCase(chaine : string) : string;
function LTrim (chaine : string) : string;
function RTrim (chaine : string) : string;
Function Alltrim (chaine : string) : string;
Function OString(Nombre, Carac : byte) : String;
Function RepAct(Lecteur : byte) : string;
Function Puissance(chiffre, exposant : word) : word;
Function HexToStr( hz : Word ) : String;
function StrToHex(chaine:string):word;

implementation

{---------------------------------------------------------------------------
 OStr : Convertit une valeur en chaine et renvoie la chaine}
Function OStr(Nombre:Longint):String;

var Chaine:string;

begin
  Str(Nombre,chaine);
  OStr:=Chaine;
end;

{----------------------------------------------------------------------------
  OStrR : Convertit un nombre  virgule en chaine et renvoie la chaine   }
Function OStrR(Nombre:real):String;

var chaine : string;

begin
  Str(Nombre:10:2,chaine);
  OStrR := Ltrim(Rtrim(Chaine));
end;

{---------------------------------------------------------------------------
 OVal : Convertit une chaine en valeur entire et renvoie la valeur}
Function OVal(Chaine:String):Longint;

var Nombre : Integer;
    code   : integer;

Begin
    Val(Chaine,Nombre,Code);
    if code=0 then
      Oval:=nombre
    else
      Oval:=code;
end;

{--------------------------------------------------------------------------
  OValR : Convertit une chaine en valuer relle et renvoie la valeur      }

Function OValR(Chaine:String):Real;

var Nombre : Real;
    code   : integer;

Begin
    Val(Chaine,Nombre,Code);
    if code=0 then
      OvalR:=nombre
    else
      OvalR:=code;
end;



{---------------------------------------------------------------------------
  UCase : Convertit une chaine en son quivalent en Majuscules et renvoie
          la chaine convertie                                }

function UCase(chaine:string):string;
var i     : byte;
    dummy : string;
begin
  if length(chaine)=1 then
    begin
      Ucase:=Upcase(chaine[1]);
      exit;
    end;
  setlength(dummy,length(chaine));
  for i:= 1 to length(chaine) do
    dummy[i]:=UpCase(chaine[i]);
  Ucase:=dummy;
end;


{---------------------------------------------------------------------------
  Ltrim : Enlve les espaces de la gauche d'une chaine                   }

function LTrim (chaine:string):string;

var posit : byte;

begin
  posit:=1;
  while ((posit<length(chaine)) and (chaine[posit]=chr(32))) do
    inc(posit);
  if posit=length(chaine) then
    begin
      ltrim:='';
      exit;
    end;
  ltrim:=copy(chaine,posit,length(chaine)-posit+1);
end;


{---------------------------------------------------------------------------
  Rtrim : Enlve les espaces de la droite d'une chaine                   }

function RTrim (chaine:string):string;

var posit : integer;

begin
  posit:=length(chaine);
  while ((posit>0) and (chaine[posit]=chr(32))) do
    dec(posit);
  if posit=-1 then
    begin
      rtrim:='';
      exit;
    end;
  rtrim:=copy(chaine,1,posit);
end;

{------------------------------------------------------------------------
  Alltrim : Fonction qui renvoie la chaine paramtre prive des espaces
            au dbut et  la fin de celle-ci                    }
function AllTrim(Chaine : string) : string;
begin
  Alltrim := Ltrim(Rtrim(Chaine));
end;

{------------------------------------------------------------------------
 OString : Fonction qui renvoie une chaine constitue du mme caractre
           rpt autant de fois que spcifi
  Entre : Nombre = Nombre de rptition du caractre
           Carac = Code Ascii du Caractre  rpter
  Sortie : Une chaine contenant Nombre fois Carac                     }

Function OString(Nombre, Carac: byte):String;

var i     : byte;
    dummy : string;

begin
  Dummy:='';
  for i:= 1 to nombre do
    Dummy:= dummy+ chr(Carac);
  Ostring := Dummy;
end;

{------------------------------------------------------------------------
  RepAct : Renvoie le rpertoire actuel du disque spcifi               }

Function RepAct(Lecteur : byte):string;

var s : string;

begin
  GetDir(Lecteur, s);
  RepAct:=s;
end;


{-------------------------------------------------------------------------
  Puissance : Renvoie un nombre  la puissance indique.
              attention, tous les nombres doivent tre entiers positifs     }

Function Puissance(chiffre, exposant : word):word;

var i     : byte;
    dummy : word;

begin
  puissance := trunc( Exp( Exposant * ln( Chiffre)));
end;


{--------------------------------------------------------------------------
 HexToStr : Convertit un nombre hexadcimal en une chane hexadcimale

 Entre : hz - valeur hexa  convertir
 Sortie : chane hexa convertie                                 }


Function hexToStr( hz : Word ) : String;
var i  : Integer;
    hs : String;
Begin
  hs := '';
  Repeat
    i := hz mod 16;
    hz := hz div 16;
    case i of
      0..9  : hs := chr( i + ord( '0' ) ) + hs;
      10..15: hs := chr( i - 10 + ord( 'A' ) ) + hs;
    End;
  Until hz = 0;
  if Odd(Length( hs )) then hs := '0' + hs;
  hexTostr := hs;
End;

{--------------------------------------------------------------------------
  StrToHex : convertit une chaine reprsentant un nombre en hexa en son
             quivalent en nombre cod sur deux octets.
             Attention : la chaine transmise doit imprativement tre
                         constitue de 4 caractres au plus.     }

function StrToHex(chaine:string):word;

var i     : byte;
    dummy : word;

begin
  strtohex:=0;
  dummy:=0;
  chaine:=ucase(chaine);
  if length(chaine)>4 then
      exit;
  if length(chaine) < 4 then
    chaine:=OString(4-length(chaine), 48)+chaine;
  for i:=0 to 3 do
    begin
      case chaine[length(chaine)-i] of
        '0'..'9' : dummy := dummy + (oval( chaine[ length( chaine )-i ] )*
                                    puissance( 16, i ));
        'A'..'F' : dummy := dummy + (( 10 + oval( chr( ord( chaine[
                                      length( chaine ) -i ] ) -17 ))) *
                                      puissance( 16, i ));
        else
          begin
            strtohex:=0;
            exit;
          end;
      end;
    end;
  strtohex:=dummy;
end;



begin
end.